bool P_in_CS = false;
bool Q_in_CS = false;
byte critical = 0;

active proctype P() {
  do
    :: printf("P non-critical actionsP\n");
  
       atomic {
         !Q_in_CS;
         P_in_CS = true
       }

       /* begin critical section */
       critical++;
       printf("P uses shared recourses\n");
       critical--;
       /* end critical section */

       P_in_CS = false
  od
}

active proctype Q() {
  do
    :: printf("Q non-critical actions\n");

       atomic {
         !P_in_CS;
         Q_in_CS = true
       }

       /* begin critical section */
       critical++;
       printf("Q uses shared recourses\n");
       critical--;
       /* end critical section */

       Q_in_CS = false
  od
}

active proctype Z() {
   assert (critical >= 0 && critical <= 1);
   /* This also works */
   assert (! (P_in_CS && Q_in_CS) )
}